<html>
<head>
<title>OgreFont.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreFont.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreFont_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*-------------------------------------------------------------------------</span>
<a name="l00002"></a>00002 <span class="comment">This source file is a part of OGRE</span>
<a name="l00003"></a>00003 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00004"></a>00004 <span class="comment"></span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00009"></a>00009 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00010"></a>00010 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00011"></a>00011 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00012"></a>00012 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00013"></a>00013 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00016"></a>00016 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00017"></a>00017 <span class="comment"></span>
<a name="l00018"></a>00018 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00019"></a>00019 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00020"></a>00020 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00021"></a>00021 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00022"></a>00022 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00023"></a>00023 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00024"></a>00024 <span class="comment">THE SOFTWARE</span>
<a name="l00025"></a>00025 <span class="comment">-------------------------------------------------------------------------*/</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#ifndef _Font_H__</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span><span class="preprocessor">#define _Font_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreResource_8h.html">OgreResource.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreTexture_8h.html">OgreTexture.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreMaterial_8h.html">OgreMaterial.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreCommon_8h.html">OgreCommon.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>Ogre
<a name="l00037"></a>00037 {
<a name="l00045"></a><a class="code" href="group__Resources.html#ga7d22ba70debe31488cdd62c5dc307ce9">00045</a>     <span class="keyword">enum</span> <a class="code" href="group__Resources.html#ga7d22ba70debe31488cdd62c5dc307ce9" title="Enumerates the types of Font usable in the engine.">FontType</a>
<a name="l00046"></a>00046     {
<a name="l00048"></a><a class="code" href="group__Resources.html#gga7d22ba70debe31488cdd62c5dc307ce9a3185a44789d385148728f61682e74354">00048</a>         <a class="code" href="group__Resources.html#gga7d22ba70debe31488cdd62c5dc307ce9a3185a44789d385148728f61682e74354" title="Generated from a truetype (.ttf) font.">FT_TRUETYPE</a> = 1,
<a name="l00050"></a><a class="code" href="group__Resources.html#gga7d22ba70debe31488cdd62c5dc307ce9ac5c0824a886f1c3946159c1303397c68">00050</a>         <a class="code" href="group__Resources.html#gga7d22ba70debe31488cdd62c5dc307ce9ac5c0824a886f1c3946159c1303397c68" title="Loaded from an image created by an artist.">FT_IMAGE</a> = 2
<a name="l00051"></a>00051     };
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00067"></a><a class="code" href="classOgre_1_1Font.html">00067</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Font.html" title="Class representing a font in the system.">Font</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a>, <span class="keyword">public</span> <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>
<a name="l00068"></a>00068     {
<a name="l00069"></a>00069     <span class="keyword">protected</span>:
<a name="l00071"></a><a class="code" href="classOgre_1_1Font_1_1CmdType.html">00071</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Font_1_1CmdType.html" title="Command object for Font - see ParamCommand.">CmdType</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00072"></a>00072         {
<a name="l00073"></a>00073         <span class="keyword">public</span>:
<a name="l00074"></a>00074             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> doGet(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00075"></a>00075             <span class="keywordtype">void</span> doSet(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00076"></a>00076         };
<a name="l00078"></a><a class="code" href="classOgre_1_1Font_1_1CmdSource.html">00078</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Font_1_1CmdSource.html" title="Command object for Font - see ParamCommand.">CmdSource</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00079"></a>00079         {
<a name="l00080"></a>00080         <span class="keyword">public</span>:
<a name="l00081"></a>00081             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> doGet(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00082"></a>00082             <span class="keywordtype">void</span> doSet(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00083"></a>00083         };
<a name="l00084"></a><a class="code" href="classOgre_1_1Font_1_1CmdCharSpacer.html">00084</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Font_1_1CmdCharSpacer.html">CmdCharSpacer</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00085"></a>00085         {
<a name="l00086"></a>00086         <span class="keyword">public</span>:
<a name="l00087"></a>00087             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> doGet(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00088"></a>00088             <span class="keywordtype">void</span> doSet(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00089"></a>00089         };
<a name="l00091"></a><a class="code" href="classOgre_1_1Font_1_1CmdSize.html">00091</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Font_1_1CmdSize.html" title="Command object for Font - see ParamCommand.">CmdSize</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00092"></a>00092         {
<a name="l00093"></a>00093         <span class="keyword">public</span>:
<a name="l00094"></a>00094             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> doGet(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00095"></a>00095             <span class="keywordtype">void</span> doSet(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00096"></a>00096         };
<a name="l00098"></a><a class="code" href="classOgre_1_1Font_1_1CmdResolution.html">00098</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Font_1_1CmdResolution.html" title="Command object for Font - see ParamCommand.">CmdResolution</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00099"></a>00099         {
<a name="l00100"></a>00100         <span class="keyword">public</span>:
<a name="l00101"></a>00101             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> doGet(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00102"></a>00102             <span class="keywordtype">void</span> doSet(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00103"></a>00103         };
<a name="l00105"></a><a class="code" href="classOgre_1_1Font_1_1CmdCodePoints.html">00105</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Font_1_1CmdCodePoints.html" title="Command object for Font - see ParamCommand.">CmdCodePoints</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00106"></a>00106         {
<a name="l00107"></a>00107         <span class="keyword">public</span>:
<a name="l00108"></a>00108             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> doGet(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00109"></a>00109             <span class="keywordtype">void</span> doSet(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00110"></a>00110         };
<a name="l00111"></a>00111 
<a name="l00112"></a>00112         <span class="comment">// Command object for setting / getting parameters</span>
<a name="l00113"></a><a class="code" href="classOgre_1_1Font.html#af8f65c5b5270ce10726fb9d0ab834384">00113</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1Font_1_1CmdType.html" title="Command object for Font - see ParamCommand.">CmdType</a> <a class="code" href="classOgre_1_1Font.html#af8f65c5b5270ce10726fb9d0ab834384">msTypeCmd</a>;
<a name="l00114"></a><a class="code" href="classOgre_1_1Font.html#ae3f0ba48bf2c41cc2f290d5f8e60697b">00114</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1Font_1_1CmdSource.html" title="Command object for Font - see ParamCommand.">CmdSource</a> <a class="code" href="classOgre_1_1Font.html#ae3f0ba48bf2c41cc2f290d5f8e60697b">msSourceCmd</a>;
<a name="l00115"></a><a class="code" href="classOgre_1_1Font.html#a3f9b51cd718d21eaebe182e6bbf5754e">00115</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1Font_1_1CmdCharSpacer.html">CmdCharSpacer</a> <a class="code" href="classOgre_1_1Font.html#a3f9b51cd718d21eaebe182e6bbf5754e">msCharacterSpacerCmd</a>;
<a name="l00116"></a><a class="code" href="classOgre_1_1Font.html#ae50fb86bcf878abcb00e280c165cce28">00116</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1Font_1_1CmdSize.html" title="Command object for Font - see ParamCommand.">CmdSize</a> <a class="code" href="classOgre_1_1Font.html#ae50fb86bcf878abcb00e280c165cce28">msSizeCmd</a>;
<a name="l00117"></a><a class="code" href="classOgre_1_1Font.html#ae67bd8aecbc074ed27ddd52a3fa0fd55">00117</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1Font_1_1CmdResolution.html" title="Command object for Font - see ParamCommand.">CmdResolution</a> <a class="code" href="classOgre_1_1Font.html#ae67bd8aecbc074ed27ddd52a3fa0fd55">msResolutionCmd</a>;
<a name="l00118"></a><a class="code" href="classOgre_1_1Font.html#a5cb99917e9be288d3f18af6eefdf8f95">00118</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1Font_1_1CmdCodePoints.html" title="Command object for Font - see ParamCommand.">CmdCodePoints</a> <a class="code" href="classOgre_1_1Font.html#a5cb99917e9be288d3f18af6eefdf8f95">msCodePointsCmd</a>;
<a name="l00119"></a>00119 
<a name="l00121"></a><a class="code" href="classOgre_1_1Font.html#a424c3f6a8669bb160ac5788ff9cb506d">00121</a>         <a class="code" href="group__Resources.html#ga7d22ba70debe31488cdd62c5dc307ce9" title="Enumerates the types of Font usable in the engine.">FontType</a> <a class="code" href="classOgre_1_1Font.html#a424c3f6a8669bb160ac5788ff9cb506d" title="The type of font.">mType</a>;
<a name="l00122"></a>00122 
<a name="l00124"></a><a class="code" href="classOgre_1_1Font.html#af22e26e8af41c90d86810260e7721eb9">00124</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1Font.html#af22e26e8af41c90d86810260e7721eb9" title="Source of the font (either an image name or a truetype font)">mSource</a>;
<a name="l00125"></a>00125 
<a name="l00128"></a><a class="code" href="classOgre_1_1Font.html#ae0d96f42f12dc1213a5ec5a62de369dd">00128</a>         <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> <a class="code" href="classOgre_1_1Font.html#ae0d96f42f12dc1213a5ec5a62de369dd" title="Add a gap between letters vertically and horizonally prevents nasty artifacts caused by fonts atypica...">mCharacterSpacer</a>;
<a name="l00129"></a>00129 
<a name="l00131"></a><a class="code" href="classOgre_1_1Font.html#ad87489de78648d7b7ce20fc0c2a6bc31">00131</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Font.html#ad87489de78648d7b7ce20fc0c2a6bc31" title="Size of the truetype font, in points.">mTtfSize</a>;
<a name="l00133"></a><a class="code" href="classOgre_1_1Font.html#aa695da6177a4d1058556647c97bb6223">00133</a>         <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> <a class="code" href="classOgre_1_1Font.html#aa695da6177a4d1058556647c97bb6223" title="Resolution (dpi) of truetype font.">mTtfResolution</a>;
<a name="l00135"></a><a class="code" href="classOgre_1_1Font.html#a7e5aba573275bf359d9aeea62824965a">00135</a>         <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1Font.html#a7e5aba573275bf359d9aeea62824965a" title="Max distance to baseline of this (truetype) font.">mTtfMaxBearingY</a>;
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 
<a name="l00138"></a>00138     <span class="keyword">public</span>:
<a name="l00139"></a><a class="code" href="classOgre_1_1Font.html#ad48cf05dd479e7c8f1d7a97221d933b1">00139</a>         <span class="keyword">typedef</span> <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">Ogre::uint32</a> <a class="code" href="classOgre_1_1Font.html#ad48cf05dd479e7c8f1d7a97221d933b1">CodePoint</a>;
<a name="l00140"></a><a class="code" href="classOgre_1_1Font.html#a17ebc3668a45365c1243a83f36a512ef">00140</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1TRect.html">Ogre::FloatRect</a> <a class="code" href="classOgre_1_1Font.html#a17ebc3668a45365c1243a83f36a512ef">UVRect</a>;
<a name="l00142"></a><a class="code" href="structOgre_1_1Font_1_1GlyphInfo.html">00142</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1Font_1_1GlyphInfo.html" title="Information about the position and size of a glyph in a texture.">GlyphInfo</a> 
<a name="l00143"></a>00143         {
<a name="l00144"></a><a class="code" href="structOgre_1_1Font_1_1GlyphInfo.html#a5df1a038d81fcf018ea7f5aac3181a62">00144</a>             <a class="code" href="classOgre_1_1Font.html#ad48cf05dd479e7c8f1d7a97221d933b1">CodePoint</a> <a class="code" href="structOgre_1_1Font_1_1GlyphInfo.html#a5df1a038d81fcf018ea7f5aac3181a62">codePoint</a>;
<a name="l00145"></a><a class="code" href="structOgre_1_1Font_1_1GlyphInfo.html#a46b20f8f199e3d2f698aa44a6553ab50">00145</a>             <a class="code" href="structOgre_1_1TRect.html">UVRect</a> <a class="code" href="structOgre_1_1Font_1_1GlyphInfo.html#a46b20f8f199e3d2f698aa44a6553ab50">uvRect</a>;
<a name="l00146"></a><a class="code" href="structOgre_1_1Font_1_1GlyphInfo.html#a4eec8222d9985bb3b15d886120fd1ae6">00146</a>             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="structOgre_1_1Font_1_1GlyphInfo.html#a4eec8222d9985bb3b15d886120fd1ae6">aspectRatio</a>;
<a name="l00147"></a>00147 
<a name="l00148"></a><a class="code" href="structOgre_1_1Font_1_1GlyphInfo.html#a8a6e99cee590d9723af63ac4a6db8849">00148</a>             <a class="code" href="structOgre_1_1Font_1_1GlyphInfo.html" title="Information about the position and size of a glyph in a texture.">GlyphInfo</a>(<a class="code" href="classOgre_1_1Font.html#ad48cf05dd479e7c8f1d7a97221d933b1">CodePoint</a> <span class="keywordtype">id</span>, <span class="keyword">const</span> <a class="code" href="structOgre_1_1TRect.html">UVRect</a>&amp; rect, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> aspect)
<a name="l00149"></a>00149                 : codePoint(id), uvRect(rect), aspectRatio(aspect)
<a name="l00150"></a>00150             {
<a name="l00151"></a>00151 
<a name="l00152"></a>00152             }
<a name="l00153"></a>00153         };
<a name="l00155"></a><a class="code" href="classOgre_1_1Font.html#aa455a399457bd458852555c696b28f6a">00155</a>         <span class="keyword">typedef</span> std::pair&lt;CodePoint, CodePoint&gt; <a class="code" href="classOgre_1_1Font.html#aa455a399457bd458852555c696b28f6a" title="A range of code points, inclusive on both ends.">CodePointRange</a>;
<a name="l00156"></a><a class="code" href="classOgre_1_1Font.html#afae0e84cc4a86dcd4fb721d137ea4011">00156</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;CodePointRange&gt;::type</a> <a class="code" href="classOgre_1_1Font.html#afae0e84cc4a86dcd4fb721d137ea4011">CodePointRangeList</a>;
<a name="l00157"></a>00157     <span class="keyword">protected</span>:
<a name="l00159"></a><a class="code" href="classOgre_1_1Font.html#a64c8bdeb1f5fd801368a895c4b9559f5">00159</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;CodePoint, GlyphInfo&gt;::type</a> <a class="code" href="classOgre_1_1Font.html#a64c8bdeb1f5fd801368a895c4b9559f5" title="Map from unicode code point to texture coordinates.">CodePointMap</a>;
<a name="l00160"></a><a class="code" href="classOgre_1_1Font.html#aa54e170af6dc8bbe4c5ae8dd68259015">00160</a>         <a class="code" href="classOgre_1_1Font.html#a64c8bdeb1f5fd801368a895c4b9559f5" title="Map from unicode code point to texture coordinates.">CodePointMap</a> <a class="code" href="classOgre_1_1Font.html#aa54e170af6dc8bbe4c5ae8dd68259015">mCodePointMap</a>;
<a name="l00161"></a>00161 
<a name="l00163"></a><a class="code" href="classOgre_1_1Font.html#a3301e54376819f64c6f72ffd82989e52">00163</a>         <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a> <a class="code" href="classOgre_1_1Font.html#a3301e54376819f64c6f72ffd82989e52" title="The material which is generated for this font.">mMaterial</a>;
<a name="l00164"></a>00164 
<a name="l00166"></a><a class="code" href="classOgre_1_1Font.html#af74681fad51c8b5394883cd0ad174930">00166</a>         <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a> <a class="code" href="classOgre_1_1Font.html#af74681fad51c8b5394883cd0ad174930" title="Texture pointer.">mTexture</a>;
<a name="l00167"></a>00167 
<a name="l00169"></a><a class="code" href="classOgre_1_1Font.html#a050d92cf95bc73cadbee4b2100cef6e0">00169</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Font.html#a050d92cf95bc73cadbee4b2100cef6e0" title="for TRUE_TYPE font only">mAntialiasColour</a>;
<a name="l00170"></a>00170 
<a name="l00172"></a><a class="code" href="classOgre_1_1Font.html#addc8e75939ee5b3f38a44d03cd3c99e2">00172</a>         <a class="code" href="classOgre_1_1Font.html#afae0e84cc4a86dcd4fb721d137ea4011">CodePointRangeList</a> <a class="code" href="classOgre_1_1Font.html#addc8e75939ee5b3f38a44d03cd3c99e2" title="Range of code points to generate glyphs for (truetype only)">mCodePointRangeList</a>;
<a name="l00173"></a>00173 
<a name="l00175"></a>00175         <span class="keywordtype">void</span> createTextureFromFont(<span class="keywordtype">void</span>);
<a name="l00176"></a>00176 
<a name="l00178"></a>00178         <span class="keyword">virtual</span> <span class="keywordtype">void</span> loadImpl();
<a name="l00180"></a>00180         <span class="keyword">virtual</span> <span class="keywordtype">void</span> unloadImpl();
<a name="l00182"></a><a class="code" href="classOgre_1_1Font.html#a3e328eceb5316086a28e7ced13fe4d16">00182</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1Font.html#a3e328eceb5316086a28e7ced13fe4d16">calculateSize</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0; } <span class="comment">// permanent resource is in the texture </span>
<a name="l00183"></a>00183     <span class="keyword">public</span>:
<a name="l00184"></a>00184 
<a name="l00188"></a>00188         <a class="code" href="classOgre_1_1Font.html" title="Class representing a font in the system.">Font</a>(<a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* creator, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> handle,
<a name="l00189"></a>00189             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual = <span class="keyword">false</span>, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader = 0);
<a name="l00190"></a>00190         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1Font.html" title="Class representing a font in the system.">Font</a>();
<a name="l00191"></a>00191 
<a name="l00193"></a>00193         <span class="keywordtype">void</span> setType(<a class="code" href="group__Resources.html#ga7d22ba70debe31488cdd62c5dc307ce9" title="Enumerates the types of Font usable in the engine.">FontType</a> ftype);
<a name="l00194"></a>00194 
<a name="l00196"></a>00196         <a class="code" href="group__Resources.html#ga7d22ba70debe31488cdd62c5dc307ce9" title="Enumerates the types of Font usable in the engine.">FontType</a> getType(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00197"></a>00197 
<a name="l00213"></a>00213         <span class="keywordtype">void</span> setSource(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; source);
<a name="l00214"></a>00214 
<a name="l00217"></a>00217         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getSource(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00218"></a>00218 
<a name="l00224"></a>00224         <span class="keywordtype">void</span> setCharacterSpacer(<a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> charSpacer);
<a name="l00225"></a>00225  
<a name="l00231"></a>00231         <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> getCharacterSpacer(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00232"></a>00232 
<a name="l00238"></a>00238         <span class="keywordtype">void</span> setTrueTypeSize(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> ttfSize);
<a name="l00243"></a>00243         <span class="keywordtype">void</span> setTrueTypeResolution(<a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> ttfResolution);
<a name="l00244"></a>00244 
<a name="l00251"></a>00251         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getTrueTypeSize(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00256"></a>00256         <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> getTrueTypeResolution(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00266"></a>00266         <span class="keywordtype">int</span> getTrueTypeMaxBearingY() <span class="keyword">const</span>;
<a name="l00267"></a>00267 
<a name="l00268"></a>00268 
<a name="l00275"></a><a class="code" href="classOgre_1_1Font.html#a9bf97678fcb0ea2369de7efb6f729801">00275</a>         <span class="keyword">inline</span> <span class="keyword">const</span> <a class="code" href="structOgre_1_1TRect.html">UVRect</a>&amp; getGlyphTexCoords(<a class="code" href="classOgre_1_1Font.html#ad48cf05dd479e7c8f1d7a97221d933b1">CodePoint</a> <span class="keywordtype">id</span>)<span class="keyword"> const</span>
<a name="l00276"></a>00276 <span class="keyword">        </span>{
<a name="l00277"></a>00277             CodePointMap::const_iterator i = mCodePointMap.find(<span class="keywordtype">id</span>);
<a name="l00278"></a>00278             <span class="keywordflow">if</span> (i != mCodePointMap.end())
<a name="l00279"></a>00279             {
<a name="l00280"></a>00280                 <span class="keywordflow">return</span> i-&gt;second.uvRect;
<a name="l00281"></a>00281             }
<a name="l00282"></a>00282             <span class="keywordflow">else</span>
<a name="l00283"></a>00283             {
<a name="l00284"></a>00284                 <span class="keyword">static</span> <a class="code" href="structOgre_1_1TRect.html">UVRect</a> nullRect(0.0, 0.0, 0.0, 0.0);
<a name="l00285"></a>00285                 <span class="keywordflow">return</span> nullRect;
<a name="l00286"></a>00286             }
<a name="l00287"></a>00287         }
<a name="l00288"></a>00288 
<a name="l00296"></a><a class="code" href="classOgre_1_1Font.html#a97480c17800578be97dc6a432983d3f2">00296</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> setGlyphTexCoords(<a class="code" href="classOgre_1_1Font.html#ad48cf05dd479e7c8f1d7a97221d933b1">CodePoint</a> <span class="keywordtype">id</span>, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> u1, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> v1, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> u2, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> v2, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> textureAspect)
<a name="l00297"></a>00297         {
<a name="l00298"></a>00298             CodePointMap::iterator i = mCodePointMap.find(<span class="keywordtype">id</span>);
<a name="l00299"></a>00299             <span class="keywordflow">if</span> (i != mCodePointMap.end())
<a name="l00300"></a>00300             {
<a name="l00301"></a>00301                 i-&gt;second.uvRect.<a class="code" href="structOgre_1_1TRect.html#a7f8310e37638f8790a89f2dd64ff3fe1">left</a> = u1;
<a name="l00302"></a>00302                 i-&gt;second.uvRect.top = v1;
<a name="l00303"></a>00303                 i-&gt;second.uvRect.right = u2;
<a name="l00304"></a>00304                 i-&gt;second.uvRect.bottom = v2;
<a name="l00305"></a>00305                 i-&gt;second.aspectRatio = textureAspect * (u2 - u1)  / (v2 - v1);
<a name="l00306"></a>00306             }
<a name="l00307"></a>00307             <span class="keywordflow">else</span>
<a name="l00308"></a>00308             {
<a name="l00309"></a>00309                 mCodePointMap.insert(
<a name="l00310"></a>00310                     CodePointMap::value_type(<span class="keywordtype">id</span>, 
<a name="l00311"></a>00311                         <a class="code" href="structOgre_1_1Font_1_1GlyphInfo.html" title="Information about the position and size of a glyph in a texture.">GlyphInfo</a>(<span class="keywordtype">id</span>, <a class="code" href="structOgre_1_1TRect.html">UVRect</a>(u1, v1, u2, v2), 
<a name="l00312"></a>00312                             textureAspect * (u2 - u1)  / (v2 - v1))));
<a name="l00313"></a>00313             }
<a name="l00314"></a>00314 
<a name="l00315"></a>00315         }
<a name="l00317"></a><a class="code" href="classOgre_1_1Font.html#aa8698754056d71474ee75ca24b47fda2">00317</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getGlyphAspectRatio(<a class="code" href="classOgre_1_1Font.html#ad48cf05dd479e7c8f1d7a97221d933b1">CodePoint</a> <span class="keywordtype">id</span>)<span class="keyword"> const</span>
<a name="l00318"></a>00318 <span class="keyword">        </span>{
<a name="l00319"></a>00319             CodePointMap::const_iterator i = mCodePointMap.find(<span class="keywordtype">id</span>);
<a name="l00320"></a>00320             <span class="keywordflow">if</span> (i != mCodePointMap.end())
<a name="l00321"></a>00321             {
<a name="l00322"></a>00322                 <span class="keywordflow">return</span> i-&gt;second.aspectRatio;
<a name="l00323"></a>00323             }
<a name="l00324"></a>00324             <span class="keywordflow">else</span>
<a name="l00325"></a>00325             {
<a name="l00326"></a>00326                 <span class="keywordflow">return</span> 1.0;
<a name="l00327"></a>00327             }
<a name="l00328"></a>00328         }
<a name="l00334"></a><a class="code" href="classOgre_1_1Font.html#aa80b463afd8a361e240a5a6856e892e3">00334</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> setGlyphAspectRatio(<a class="code" href="classOgre_1_1Font.html#ad48cf05dd479e7c8f1d7a97221d933b1">CodePoint</a> <span class="keywordtype">id</span>, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> ratio)
<a name="l00335"></a>00335         {
<a name="l00336"></a>00336             CodePointMap::iterator i = mCodePointMap.find(<span class="keywordtype">id</span>);
<a name="l00337"></a>00337             <span class="keywordflow">if</span> (i != mCodePointMap.end())
<a name="l00338"></a>00338             {
<a name="l00339"></a>00339                 i-&gt;second.aspectRatio = ratio;
<a name="l00340"></a>00340             }
<a name="l00341"></a>00341         }
<a name="l00342"></a>00342 
<a name="l00346"></a>00346         <span class="keyword">const</span> GlyphInfo&amp; getGlyphInfo(CodePoint <span class="keywordtype">id</span>) <span class="keyword">const</span>;
<a name="l00347"></a>00347 
<a name="l00356"></a><a class="code" href="classOgre_1_1Font.html#ac2c1fba5ad2d610ecc78b1e1a6a1b8dc">00356</a>         <span class="keywordtype">void</span> addCodePointRange(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Font.html#aa455a399457bd458852555c696b28f6a" title="A range of code points, inclusive on both ends.">CodePointRange</a>&amp; range)
<a name="l00357"></a>00357         {
<a name="l00358"></a>00358             mCodePointRangeList.push_back(range);
<a name="l00359"></a>00359         }
<a name="l00360"></a>00360 
<a name="l00363"></a><a class="code" href="classOgre_1_1Font.html#aff75a40e8ca00a64f19c265e90c61733">00363</a>         <span class="keywordtype">void</span> clearCodePointRanges()
<a name="l00364"></a>00364         {
<a name="l00365"></a>00365             mCodePointRangeList.clear();
<a name="l00366"></a>00366         }
<a name="l00370"></a><a class="code" href="classOgre_1_1Font.html#a76de13c95888cc0f9894db7e5991b60f">00370</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Font.html#afae0e84cc4a86dcd4fb721d137ea4011">CodePointRangeList</a>&amp; getCodePointRangeList()<span class="keyword"> const</span>
<a name="l00371"></a>00371 <span class="keyword">        </span>{
<a name="l00372"></a>00372             <span class="keywordflow">return</span> mCodePointRangeList;
<a name="l00373"></a>00373         }
<a name="l00378"></a><a class="code" href="classOgre_1_1Font.html#aa5870a50a6c7f3d6fd6e93eb319b9283">00378</a>         <span class="keyword">inline</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; getMaterial()<span class="keyword"> const</span>
<a name="l00379"></a>00379 <span class="keyword">        </span>{
<a name="l00380"></a>00380             <span class="keywordflow">return</span> mMaterial;
<a name="l00381"></a>00381         }
<a name="l00386"></a><a class="code" href="classOgre_1_1Font.html#a354eac639a3afd4bfe797a208f6c90ce">00386</a>         <span class="keyword">inline</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; getMaterial()
<a name="l00387"></a>00387         {
<a name="l00388"></a>00388             <span class="keywordflow">return</span> mMaterial;
<a name="l00389"></a>00389         }
<a name="l00401"></a><a class="code" href="classOgre_1_1Font.html#a6ca4172a3f554f07752997b1a25278c0">00401</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> setAntialiasColour(<span class="keywordtype">bool</span> enabled)
<a name="l00402"></a>00402         {
<a name="l00403"></a>00403             mAntialiasColour = enabled;
<a name="l00404"></a>00404         }
<a name="l00405"></a>00405 
<a name="l00409"></a><a class="code" href="classOgre_1_1Font.html#a343dcde3799731dc8613eb5ba9032da6">00409</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> getAntialiasColour(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00410"></a>00410 <span class="keyword">        </span>{
<a name="l00411"></a>00411             <span class="keywordflow">return</span> mAntialiasColour;
<a name="l00412"></a>00412         }
<a name="l00413"></a>00413 
<a name="l00417"></a>00417         <span class="keywordtype">void</span> loadResource(<a class="code" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a>* resource);
<a name="l00418"></a>00418     };
<a name="l00425"></a><a class="code" href="classOgre_1_1FontPtr.html">00425</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1FontPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to FontPtr.">FontPtr</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;Font&gt; 
<a name="l00426"></a>00426     {
<a name="l00427"></a>00427     <span class="keyword">public</span>:
<a name="l00428"></a><a class="code" href="classOgre_1_1FontPtr.html#ab9338cdc938cc2bf3db93c6305355f3b">00428</a>         <a class="code" href="classOgre_1_1FontPtr.html#ab9338cdc938cc2bf3db93c6305355f3b">FontPtr</a>() : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1Font.html" title="Class representing a font in the system.">Font</a>&gt;() {}
<a name="l00429"></a><a class="code" href="classOgre_1_1FontPtr.html#a64d9010dbcb52f5552a832e370c7deb4">00429</a>         <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1FontPtr.html#a64d9010dbcb52f5552a832e370c7deb4">FontPtr</a>(<a class="code" href="classOgre_1_1Font.html" title="Class representing a font in the system.">Font</a>* rep) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1Font.html" title="Class representing a font in the system.">Font</a>&gt;(rep) {}
<a name="l00430"></a><a class="code" href="classOgre_1_1FontPtr.html#a12139eda04c3d5c09e239027abea2201">00430</a>         <a class="code" href="classOgre_1_1FontPtr.html#a12139eda04c3d5c09e239027abea2201">FontPtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1FontPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to FontPtr.">FontPtr</a>&amp; r) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1Font.html" title="Class representing a font in the system.">Font</a>&gt;(r) {} 
<a name="l00431"></a><a class="code" href="classOgre_1_1FontPtr.html#add5d337ad5322530c826d62ca8a1ecf5">00431</a>         <a class="code" href="classOgre_1_1FontPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to FontPtr.">FontPtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a>&amp; r) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1Font.html" title="Class representing a font in the system.">Font</a>&gt;()
<a name="l00432"></a>00432         {
<a name="l00433"></a>00433             <span class="comment">// lock &amp; copy other mutex pointer</span>
<a name="l00434"></a>00434             <a class="code" href="OgrePrerequisites_8h.html#a2201eef4cf31a94b24d79de6de3445af">OGRE_MUTEX_CONDITIONAL</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00435"></a>00435             {
<a name="l00436"></a>00436                 <a class="code" href="OgrePrerequisites_8h.html#a8a4683cdaf73994ea7ec391c1ba82b60">OGRE_LOCK_MUTEX</a>(*r.OGRE_AUTO_MUTEX_NAME)
<a name="l00437"></a>00437                 <a class="code" href="OgrePrerequisites_8h.html#acf02af48b9d015cd2f0c10e22466c73a">OGRE_COPY_AUTO_SHARED_MUTEX</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00438"></a>00438                 pRep = <span class="keyword">static_cast&lt;</span><a class="code" href="classOgre_1_1Font.html" title="Class representing a font in the system.">Font</a>*<span class="keyword">&gt;</span>(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>());
<a name="l00439"></a>00439                 pUseCount = r.<a class="code" href="classOgre_1_1SharedPtr.html#a21c3410c03ec3a4647c7aaa8e59d535d">useCountPointer</a>();
<a name="l00440"></a>00440                 <span class="keywordflow">if</span> (pUseCount)
<a name="l00441"></a>00441                 {
<a name="l00442"></a>00442                     ++(*pUseCount);
<a name="l00443"></a>00443                 }
<a name="l00444"></a>00444             }
<a name="l00445"></a>00445         }
<a name="l00446"></a>00446 
<a name="l00448"></a><a class="code" href="classOgre_1_1FontPtr.html#a59dc04f6e3800dc74639d7220d0f4f84">00448</a>         <a class="code" href="classOgre_1_1FontPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to FontPtr.">FontPtr</a>&amp; operator=(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a>&amp; r)
<a name="l00449"></a>00449         {
<a name="l00450"></a>00450             <span class="keywordflow">if</span> (pRep == static_cast&lt;Font*&gt;(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>()))
<a name="l00451"></a>00451                 <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00452"></a>00452             release();
<a name="l00453"></a>00453             <span class="comment">// lock &amp; copy other mutex pointer</span>
<a name="l00454"></a>00454             <a class="code" href="OgrePrerequisites_8h.html#a2201eef4cf31a94b24d79de6de3445af">OGRE_MUTEX_CONDITIONAL</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00455"></a>00455             {
<a name="l00456"></a>00456                 <a class="code" href="OgrePrerequisites_8h.html#a8a4683cdaf73994ea7ec391c1ba82b60">OGRE_LOCK_MUTEX</a>(*r.OGRE_AUTO_MUTEX_NAME)
<a name="l00457"></a>00457                 <a class="code" href="OgrePrerequisites_8h.html#acf02af48b9d015cd2f0c10e22466c73a">OGRE_COPY_AUTO_SHARED_MUTEX</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00458"></a>00458                 pRep = <span class="keyword">static_cast&lt;</span><a class="code" href="classOgre_1_1Font.html" title="Class representing a font in the system.">Font</a>*<span class="keyword">&gt;</span>(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>());
<a name="l00459"></a>00459                 pUseCount = r.<a class="code" href="classOgre_1_1SharedPtr.html#a21c3410c03ec3a4647c7aaa8e59d535d">useCountPointer</a>();
<a name="l00460"></a>00460                 <span class="keywordflow">if</span> (pUseCount)
<a name="l00461"></a>00461                 {
<a name="l00462"></a>00462                     ++(*pUseCount);
<a name="l00463"></a>00463                 }
<a name="l00464"></a>00464             }
<a name="l00465"></a>00465             <span class="keywordflow">else</span>
<a name="l00466"></a>00466             {
<a name="l00467"></a>00467                 <span class="comment">// RHS must be a null pointer</span>
<a name="l00468"></a>00468                 assert(r.<a class="code" href="classOgre_1_1SharedPtr.html#a8a223db784efd7aa766792649de2f2a0">isNull</a>() &amp;&amp; <span class="stringliteral">&quot;RHS must be null if it has no mutex!&quot;</span>);
<a name="l00469"></a>00469                 setNull();
<a name="l00470"></a>00470             }
<a name="l00471"></a>00471             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00472"></a>00472         }
<a name="l00473"></a>00473     };
<a name="l00476"></a>00476 }
<a name="l00477"></a>00477 
<a name="l00478"></a>00478 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
